﻿@using AdminCaja.Areas.Admin.Models
@using AdminCaja.Helpers
@model ContentViewModel
@{
    var options = new AjaxOptions()
    {
        InsertionMode = InsertionMode.Replace,
        UpdateTargetId = "formContainer",
        OnComplete = "initSummerNote()"
    };
}

    <div id="formContainer">
        @using (Ajax.BeginForm("SaveSection", "Section", options, new { @class = "form-horizontal form-material", id = "EditForm", enctype = "multipart/form-data" }))
        {
            <input type="hidden" name="Id" id="Id" value="@Model.Id" />
            @Html.HiddenFor(m => m.SectionId)
            @Html.HiddenFor(m => m.Language)

            @Html.AntiForgeryToken()

            <div class="form-group">
                @Html.LabelFor(m => m.Title, new { htmlAttributes = new { @class = "form-control form-control-line" } })
                @Html.EditorFor(m => m.Title, new { htmlAttributes = new { @class = "form-control form-control-line" } })
                @Html.ValidationMessageFor(m => m.Title)
            </div>

            <div class="form-group">
                <div class="d-flex justify-content-between align-items-center mb-2">
                    <label class="h6 small d-block text-uppercase mb-0">Cargar imagen de Encabezado</label>
                </div>
                <div class="js-focus-state input-group u-form">

                    <input type="file" name="ImageFile" id="ImageFile" style="position: absolute;" class="inputfile custom form-control u-form__input" />
                    <label for="ImageFile"><span id="file_name">@Model.FileName</span><strong>Seleccionar imagen</strong></label>
                </div>
            </div>
            if (Model.HasContent)
            {
                <div class="form-group">
                    <label class="h6 small d-block text-uppercase mb-0">Habilitar Contenidos</label><br>
                    <span class="switch-text t1">Deshabilitar  </span>
                    @Html.CustomCheckBoxFor(m => m.ContentEnabled)
                    <span class="switch-text t2">  Habilitar</span>
                </div>
            }
    <div id="target">
        @if (Model.HasContent)
        {

            <div class="form-group">
                <label class="h6 small d-block text-uppercase">Cuerpo de publicación</label>
                <div class="js-focus-state input-group u-form">
                    <div class="u-summernote-editor" style="width: 100%">
                        @Html.TextAreaFor(m => m.Body, new { @class = "js-summernote-editor", data_height = "240" })
                    </div>
                </div>
            </div>
        }

        @if (Model.HasDocuments)
        {

            <div class="form-group">
                <div class="d-flex justify-content-between align-items-center mb-2">
                    <label class="h6 small d-block text-uppercase mb-0">Cargar documentos descargables</label>
                </div>
                <div class="js-focus-state input-group u-form">
                    <input type="file" name="DocFile" id="DocFile"
                           onchange="handleFiles(this.files);"
                           style="position: absolute;" class="inputfile custom form-control u-form__input" />
                    <label for="DocFile"><span id="file_name">archivo.doc</span><strong>Seleccionar documento</strong></label>
                    <div id="progress" class="progress hide">
                        <div class="progress-bar" role="progressbar" aria-valuenow="70" aria-valuemin="0" aria-valuemax="100" style="width:0%">
                            <span class="sr-only">0% Completado</span>
                        </div>
                    </div>
                </div>
            </div>
            @Html.Partial("EditFormDocuments", Model.Files)
        }
        </div>
            <div class="col-md-12 mt-5">
                <button type="submit" class="btn btn-primary u-btn-primary transition-3d-hover">Publicar</button>
            </div>
        }
    </div>


@using (Html.BeginScripts())
{
    <script>

        function handleFiles(files) {

            if (files.length > 0) {
                var file = files[0];
                uploadFile(file,
                    function (data) {
                        $("#formContainer").load("/Admin/Section/GetContent/@Model.Id",
                            function () {
                                initSummerNote();
                            });
                        
                },
                    function (p) { progress(p); });
            }
        };

        function uploadFile(file, success, progress) {
            var ajaxData = new FormData();
            var bloque = $("#progress");

            bloque.show();

            function progress(percent, bloque) {
                bloque.find('.progress-bar').css({
                    width: percent * 100 + '%'
                }).attr('aria-valuenow', percent * 100);
                if (percent === 1) {
                    bloque.children('.progress-bar').addClass('hide');
                }
            }

            ajaxData.append("ContentId", @Model.Id);
            ajaxData.append("file", file);
            ajaxData.append("language", "@Model.Language");

            $.ajax({
                url: '/Admin/Section/AddFile', type: 'post', data: ajaxData, dataType: 'json',
                contentType: false, processData: false,
                complete: function () { success; },
                success: function (data) {
                    console.log("Imagen subida", data);
                    bloque.hide();
                    success(data);
                },
                xhr: function () {
                    var xhr = new window.XMLHttpRequest();
                    xhr.upload.addEventListener("progress", function (evt) {
                        if (evt.lengthComputable) {
                            var percentComplete = evt.loaded / evt.total;
                            progress(percentComplete, bloque);
                        }
                    }, false);
                    xhr.addEventListener("progress", function (evt) {
                        if (evt.lengthComputable) {
                            var percentComplete = evt.loaded / evt.total;
                            progress(percentComplete, bloque);
                        }
                    }, false);
                    return xhr;
                }
            });
        }

        function deleteFile(id) {
            $("#formContainer").load("/Admin/Section/DeleteFile/" + id,
                            function () {
                                initSummerNote();
                            });
        }
    </script>
}
